package cpcns.danganzhengli.zhongdahuodong.controller;

package .var.folders.cl.9twcgjfx4vsg5zl73c6wxmvm0000gn.T;

import cpcns.base.common.User;
import cpcns.base.common.util.JsonWithJacksonUtils;
import cpcns.base.configuration.AppConfiguration;
import cpcns.base.generic.ResultMessage;
import cpcns.common.controller.commonController;
import cpcns.common.service.ICommonService;
import cpcns.danganzhengli.zhongdahuodong.model.ZhongDaHuoDong;
import cpcns.danganzhengli.zhongdahuodong.model.ZhongDaHuoDongFuJian;
import cpcns.danganzhengli.zhongdahuodong.service.IZhongDaHuoDongFuJianService;
import cpcns.danganzhengli.zhongdahuodong.service.IZhongDaHuoDongService;
import cpcns.gongyongzujian.dianzidangan.util.FuJianPathUtils;
import cpcns.utils.CommStatic;
import cpcns.utils.FtpConfig;
import cpcns.utils.FtpUtil;
import cpcns.utils.PagerVO;
import cpcns.utils.StringUtil;
import java.io.File;
import java.io.IOException;
import java.net.SocketException;
import java.text.SimpleDateFormat;
import java.util.Calendar;
import java.util.Date;
import java.util.Enumeration;
import java.util.Iterator;
import java.util.List;
import javax.servlet.http.HttpServletRequest;
import javax.servlet.http.HttpServletResponse;
import net.sf.json.JSONObject;
import org.apache.commons.io.FileUtils;
import org.apache.commons.lang.StringUtils;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Controller;
import org.springframework.web.bind.annotation.RequestMapping;
import org.springframework.web.bind.annotation.ResponseBody;

@Controller
@RequestMapping({"/zhongDaHuoDong"})
public class ZhongDaHuoDongController extends commonController {
  @Autowired
  private IZhongDaHuoDongService zhongDaHuoDongService;
  
  @Autowired
  private IZhongDaHuoDongFuJianService zhongDaHuoDongFuJianService;
  
  @Autowired
  private ICommonService commonService;
  
  @RequestMapping({"/query"})
  public String query(HttpServletRequest request) {
    String yuanFenLeiHao = request.getParameter("yuanFenLeiHao");
    String xiTongLeiXing = AppConfiguration.getConfigValue("CPCNS_XITONGLEIXING");
    if (StringUtils.isBlank(yuanFenLeiHao))
      yuanFenLeiHao = AppConfiguration.getConfigValue("ZhongDaHuoDongDangHaoQianZhui"); 
    getRequest().setAttribute("xiTongLeiXing", xiTongLeiXing);
    getRequest().setAttribute("yuanFenLeiHao", yuanFenLeiHao);
    return "/danganzhengli/zhongdahuodong/ZhongDaHuoDongList";
  }
  
  @RequestMapping({"/newAdd"})
  public String newAdd(HttpServletRequest request, HttpServletResponse response) {
    String xiTongLeiXing = getRequest().getParameter("xiTongLeiXing");
    String yuanFenLeiHao = getRequest().getParameter("yuanFenLeiHao");
    if (StringUtils.isNotBlank(xiTongLeiXing)) {
      User user = getCurrentUser();
      String dw = user.findRootBuMenMingCheng();
      String bs = user.findRootBuMenBiaoShi();
      ZhongDaHuoDong ZhongDaHuoDong = new ZhongDaHuoDong();
      ZhongDaHuoDong.setHangBiaoShi(Integer.valueOf(this.zhongDaHuoDongService.getPk()));
      if (xiTongLeiXing.equals("2")) {
        ZhongDaHuoDong.setHuoDongDanZhuangTai(Integer.valueOf(5));
      } else {
        ZhongDaHuoDong.setHuoDongDanZhuangTai(Integer.valueOf(0));
      } 
      ZhongDaHuoDong.setDengJiRenMingCheng(user.getMingCheng());
      ZhongDaHuoDong.setDengJiRenBiaoShi(user.getBiaoShi());
      ZhongDaHuoDong.setDanWeiBiaoShi(Integer.valueOf(Integer.parseInt(bs)));
      ZhongDaHuoDong.setDanWeiMingCheng(dw);
      ZhongDaHuoDong.setQuanZongHao(user.getQuanZongHao());
      ZhongDaHuoDong.setGuiDangNianDu((new SimpleDateFormat("yyyy")).format(new Date()));
      if (StringUtils.isNotBlank(yuanFenLeiHao))
        ZhongDaHuoDong.setYuanFenLeiHao(yuanFenLeiHao); 
      String pathPre = AppConfiguration.getConfigValue("CPCNS0412_DangAnFuJian");
      getRequest().setAttribute("pathPre", pathPre);
      getRequest().setAttribute("ZhongDaHuoDong", ZhongDaHuoDong);
      getRequest().setAttribute("state", Integer.valueOf(1));
      getRequest().setAttribute("wenJian", Integer.valueOf(0));
      getRequest().setAttribute("zhaoPian", Integer.valueOf(0));
      getRequest().setAttribute("luYin", Integer.valueOf(0));
      getRequest().setAttribute("luXiang", Integer.valueOf(0));
      getRequest().setAttribute("shiWu", Integer.valueOf(0));
      getRequest().setAttribute("xiTongLeiXing", xiTongLeiXing);
    } 
    return "/danganzhengli/zhongdahuodong/ZhongDaHuoDongEdit";
  }
  
  @RequestMapping({"/openZDHD"})
  public String openZDHD(HttpServletRequest request, HttpServletResponse response) {
    String hangBiaoShi = getRequest().getParameter("hangBiaoShi");
    String xiTongLeiXing = getRequest().getParameter("xiTongLeiXing");
    if (StringUtils.isNotBlank(hangBiaoShi) && StringUtils.isNotBlank(xiTongLeiXing)) {
      ZhongDaHuoDong ZhongDaHuoDong = (ZhongDaHuoDong)this.zhongDaHuoDongService.getById(Integer.valueOf(Integer.parseInt(hangBiaoShi)));
      if (ZhongDaHuoDong != null) {
        StringBuffer sql_WJ = new StringBuffer("select count(hangBiaoShi) from D_ZhongDaHuoDongFuJian where guanLianBiaoShi=" + hangBiaoShi + " and leiXing=0");
        StringBuffer sql_ZP = new StringBuffer("select count(hangBiaoShi) from D_ZhongDaHuoDongFuJian where guanLianBiaoShi=" + hangBiaoShi + " and leiXing=1");
        StringBuffer sql_LY = new StringBuffer("select sum(shiChang) from D_ZhongDaHuoDongFuJian where guanLianBiaoShi=" + hangBiaoShi + " and leiXing=2");
        StringBuffer sql_LX = new StringBuffer("select sum(shiChang) from D_ZhongDaHuoDongFuJian where guanLianBiaoShi=" + hangBiaoShi + " and leiXing=3");
        StringBuffer sql_SW = new StringBuffer("select count(hangBiaoShi) from D_ZhongDaHuoDongFuJian where guanLianBiaoShi=" + hangBiaoShi + " and leiXing=4");
        List li_WJ = this.zhongDaHuoDongService.getList(sql_WJ.toString());
        if (li_WJ != null && li_WJ.size() > 0 && li_WJ.get(0) != null) {
          getRequest().setAttribute("wenJian", li_WJ.get(0));
        } else {
          getRequest().setAttribute("wenJian", Integer.valueOf(0));
        } 
        List li_ZP = this.zhongDaHuoDongService.getList(sql_ZP.toString());
        if (li_ZP != null && li_ZP.size() > 0 && li_ZP.get(0) != null) {
          getRequest().setAttribute("zhaoPian", li_ZP.get(0));
        } else {
          getRequest().setAttribute("zhaoPian", Integer.valueOf(0));
        } 
        List li_LY = this.zhongDaHuoDongService.getList(sql_LY.toString());
        if (li_LY != null && li_LY.size() > 0 && li_LY.get(0) != null) {
          getRequest().setAttribute("luYin", li_LY.get(0));
        } else {
          getRequest().setAttribute("luYin", Integer.valueOf(0));
        } 
        List li_LX = this.zhongDaHuoDongService.getList(sql_LX.toString());
        if (li_LX != null && li_LX.size() > 0 && li_LX.get(0) != null) {
          getRequest().setAttribute("luXiang", li_LX.get(0));
        } else {
          getRequest().setAttribute("luXiang", Integer.valueOf(0));
        } 
        List li_SW = this.zhongDaHuoDongService.getList(sql_SW.toString());
        if (li_SW != null && li_SW.size() > 0 && li_SW.get(0) != null) {
          getRequest().setAttribute("shiWu", li_SW.get(0));
        } else {
          getRequest().setAttribute("shiWu", Integer.valueOf(0));
        } 
      } 
      getRequest().setAttribute("ZhongDaHuoDong", ZhongDaHuoDong);
      getRequest().setAttribute("xiTongLeiXing", xiTongLeiXing);
      this.zhongDaHuoDongService.addDA_RiZhi(getCurrentUser(), this.server, "D_ZhongDaHuoDong", ZhongDaHuoDong.getHangBiaoShi(), String.valueOf(ZhongDaHuoDong.getHuoDongMingCheng()) + "$." + ZhongDaHuoDong.getFenLeiHao() + "$." + "ZDHD", "查看");
    } 
    String pathPre = AppConfiguration.getConfigValue("CPCNS0412_DangAnFuJian");
    getRequest().setAttribute("pathPre", pathPre);
    getRequest().setAttribute("state", Integer.valueOf(2));
    return "/danganzhengli/zhongdahuodong/ZhongDaHuoDongEdit";
  }
  
  @RequestMapping({"/getAll"})
  public String getAll(HttpServletRequest request, HttpServletResponse response) throws IOException {
    Enumeration<?> rnames = getRequest().getParameterNames();
    JSONObject jsonObject = new JSONObject();
    for (Enumeration<?> er = rnames; er.hasMoreElements(); ) {
      String thisName = er.nextElement().toString();
      String thisValue = getRequest().getParameter(thisName);
      if (!"querystr".equals(thisName))
        jsonObject.put(thisName, thisValue); 
    } 
    StringBuffer sqlWhere = new StringBuffer();
    Iterator<String> iterator = jsonObject.keys();
    while (iterator.hasNext()) {
      String key = iterator.next();
      String value = jsonObject.getString(key);
      if (value != null && !value.trim().equals("") && !key.equals("page") && !key.equals("rows") && !"order".equals(key) && !"sort".equals(key) && !"type".equals(key) && !"leiXing".equals(key)) {
        if (key.contains("begin")) {
          key = key.substring(0, key.indexOf("begin"));
          sqlWhere.append(" and ").append(
              String.valueOf(key) + " >= to_date('" + value + "','yyyy-mm-dd') ");
          continue;
        } 
        if (key.contains("end")) {
          key = key.substring(0, key.indexOf("end"));
          sqlWhere.append(" and ").append(
              String.valueOf(key) + " <= to_date('" + value + "','yyyy-mm-dd') ");
          continue;
        } 
        if (!"server".equals(key) && !"table".equals(key)) {
          if (!key.contains("like")) {
            if (key.equals("yuanFenLeiHao") && value.equals("null")) {
              value = " is null";
              continue;
            } 
            sqlWhere.append(" and ").append(String.valueOf(key) + " like '%" + value + "%'");
            continue;
          } 
          key = key.substring(0, key.indexOf("like"));
          sqlWhere.append(" and ").append(String.valueOf(key) + " like " + "'%" + value.trim() + "%'");
        } 
      } 
    } 
    String querySt = request.getParameter("querystr");
    if (StringUtils.isNotBlank(querySt))
      sqlWhere.append(" ").append(CommStatic.zhuHeQueryJieXi_(querySt)); 
    String page = request.getParameter("page");
    String rows = request.getParameter("rows");
    int intPage = Integer.parseInt((page == null || page == "0") ? "0" : page);
    int number = Integer.parseInt((rows == null || rows == "0") ? "0" : rows);
    int start = (intPage - 1) * number;
    PagerVO pagevo = this.zhongDaHuoDongService.getAllOderBy(start, number, sqlWhere.toString(), " order by hangBiaoShi desc");
    String jsonString = JsonWithJacksonUtils.getInstance().obj2Json(pagevo);
    jsonString = StringUtil.replaceEntity(jsonString, ZhongDaHuoDong.class);
    write(response, jsonString);
    return null;
  }
  
  @RequestMapping({"/saveZDHD.do"})
  @ResponseBody
  public void saveZDHD(HttpServletRequest request, HttpServletResponse response) {
    ResultMessage rm = new ResultMessage();
    String info = "";
    Enumeration<?> rnames = getRequest().getParameterNames();
    JSONObject jsonObject = new JSONObject();
    for (Enumeration<?> er = rnames; er.hasMoreElements(); ) {
      String thisName = er.nextElement().toString();
      String thisValue = getRequest().getParameter(thisName);
      jsonObject.put(thisName, thisValue);
    } 
    ZhongDaHuoDong zdhd = (ZhongDaHuoDong)JsonWithJacksonUtils.getInstance().json2Obj(jsonObject.toString(), ZhongDaHuoDong.class);
    try {
      String flhqz = AppConfiguration.getConfigValue("ZhongDaHuoDongDangHaoQianZhui");
      String qzh = AppConfiguration.getConfigValue("CPCNS_QUANZHONGHAO");
      String rizhiInfo = "修改";
      String state = getRequest().getParameter("state");
      if ("1".equals(state)) {
        rizhiInfo = "新增";
        String fenLeiHao = "";
        StringBuffer sql = new StringBuffer("select max(xuHao) from D_ZhongDaHuoDong");
        sql.append(" where guidangniandu=").append(zdhd.getGuiDangNianDu()).append(" and quanzonghao='").append(zdhd.getQuanZongHao()).append("'");
        List<E> lis = this.zhongDaHuoDongService.getList(sql.toString());
        Integer xuHao = Integer.valueOf(1);
        if (lis != null && lis.size() > 0 && lis.get(0) != null)
          xuHao = Integer.valueOf(Integer.parseInt(lis.get(0).toString()) + 1); 
        if (qzh.equals("B010")) {
          fenLeiHao = String.valueOf(zdhd.getQuanZongHao()) + "-ZD·" + zdhd.getGuiDangNianDu() + "-" + zdhd.getBaoGuanQiXian() + "-" + xuHao;
        } else {
          fenLeiHao = String.valueOf(flhqz) + zdhd.getQuanZongHao() + "-" + zdhd.getGuiDangNianDu() + "-" + xuHao;
        } 
        zdhd.setFenLeiHao(fenLeiHao);
        zdhd.setXuHao(xuHao);
      } 
      if (zdhd.getHuoDongDanZhuangTai().intValue() == 0 || zdhd.getHuoDongDanZhuangTai().intValue() == 3)
        zdhd.setHuoDongDanZhuangTai(Integer.valueOf(1)); 
      if (zdhd.getDengJiRiQi() == null || "".equals(zdhd.getDengJiRiQi()))
        zdhd.setDengJiRiQi(new Date()); 
      this.zhongDaHuoDongService.saveOrUpdate(zdhd);
      rm.setSuccess(true);
      rm.addResultMessage("hangBiaoShi", zdhd.getHangBiaoShi());
      info = "保存成功！";
      this.zhongDaHuoDongService.addDA_RiZhi(getCurrentUser(), this.server, "D_ZhongDaHuoDong", zdhd.getHangBiaoShi(), String.valueOf(zdhd.getHuoDongMingCheng()) + "$." + zdhd.getFenLeiHao() + "$." + "ZDHD", rizhiInfo);
    } catch (Exception e) {
      e.printStackTrace();
      info = "保存失败！";
      rm.setSuccess(false);
    } 
    rm.setInfo(info);
    responseWriter(response, rm.toString());
  }
  
  @RequestMapping({"/delZDHD.do"})
  @ResponseBody
  public void delZDHD(HttpServletRequest request, HttpServletResponse response) throws SocketException, IOException {
    String hangBiaoShis = getRequest().getParameter("hangBiaoShis");
    String info = "";
    if (StringUtils.isNotBlank(hangBiaoShis)) {
      String[] hangBiaoShi = hangBiaoShis.split(",");
      for (int i = 0; i < hangBiaoShi.length; i++) {
        ZhongDaHuoDong zdhd = (ZhongDaHuoDong)this.zhongDaHuoDongService.getById(Integer.valueOf(Integer.parseInt(hangBiaoShi[i])));
        StringBuffer sqlDelZDHD = new StringBuffer("delete from D_ZhongDaHuoDong where hangBiaoShi=" + hangBiaoShi[i]);
        this.zhongDaHuoDongService.deleteBySql(sqlDelZDHD.toString());
        this.zhongDaHuoDongService.addDA_RiZhi(getCurrentUser(), this.server, "D_ZhongDaHuoDong", zdhd.getHangBiaoShi(), String.valueOf(zdhd.getHuoDongMingCheng()) + "$." + zdhd.getFenLeiHao() + "$." + "ZDHD", "删除");
        StringBuffer getFJ = new StringBuffer("from ZhongDaHuoDongFuJian where guanLianBiaoShi=" + hangBiaoShi[i]);
        List<ZhongDaHuoDongFuJian> list = this.zhongDaHuoDongService.getListHQL("ZhongDaHuoDongFuJian", getFJ.toString());
        if (list != null && list.size() > 0)
          for (int n = 0; n < list.size(); n++) {
            ZhongDaHuoDongFuJian zdfj = list.get(n);
            StringBuffer sql = new StringBuffer("delete from D_ZhongDaHuoDongFuJian where hangBiaoShi=" + zdfj.getHangBiaoShi());
            this.zhongDaHuoDongFuJianService.deleteBySql(sql.toString());
            String CPCNS_CUNCHUFANGSHI = AppConfiguration.getConfigValue("CPCNS_CUNCHUFANGSHI");
            String path = StringUtil.dealBasePath(AppConfiguration.getConfigValue("DangAnYuanWenPath"));
            String fuJianPath = StringUtil.dealBasePath(String.valueOf(path) + File.separator + zdfj.getWenJianLuJing());
            if (CPCNS_CUNCHUFANGSHI.equals("1")) {
              fuJianPath = StringUtil.dealBasePath(String.valueOf(zdfj.getWenJianLuJing()) + zdfj.getWenJianMing());
              Integer guanlianbiaoshi = zdfj.getGuanLianBiaoShi();
              Integer index = Integer.valueOf(fuJianPath.indexOf(String.valueOf(guanlianbiaoshi)));
              FtpUtil ftp = new FtpUtil();
              String quanZongHao = getFtpQuanZong();
              FtpConfig ftpConfig = this.zhongDaHuoDongFuJianService.getFtpAccInfo(quanZongHao);
              ftp.connectServer(ftpConfig);
              boolean deleteFTP = ftp.deleteFile(fuJianPath);
              System.out.println(deleteFTP);
              ftp.closeServer();
            } else {
              if (!fuJianPath.endsWith("/"))
                fuJianPath = String.valueOf(fuJianPath) + "/"; 
              Integer guanlianbiaoshi = zdfj.getGuanLianBiaoShi();
              Integer index = Integer.valueOf(fuJianPath.indexOf(String.valueOf(guanlianbiaoshi)));
              String fuJianPaths = StringUtils.substring(fuJianPath, 0, index.intValue());
              fuJianPaths = String.valueOf(fuJianPaths) + String.valueOf(guanlianbiaoshi);
              File file = new File(String.valueOf(fuJianPath) + zdfj.getWenJianMing());
              if (file.exists()) {
                file.delete();
                FileUtils.deleteDirectory(new File(fuJianPaths));
              } 
            } 
          }  
      } 
      info = "删除成功！";
    } 
    responseWriter(response, info);
  }
  
  protected String getPath(String table, String quanZong, Integer hangBiaoShi) {
    Calendar cal = Calendar.getInstance();
    int year = cal.get(1);
    if (StringUtils.isBlank(quanZong))
      quanZong = "001"; 
    String path = String.valueOf(quanZong) + File.separator + year + File.separator + table + File.separator + hangBiaoShi + File.separator;
    path = FuJianPathUtils.dealBasePath(path);
    return path;
  }
}
